<?php
/**
 *  Indexreloaded-backend
 *
 *  The indexreloaded-backend.php performs tasks when Indexreloaded is loaded in backend
 *
 *  @package Indexreloaded
 */

defined( 'ABSPATH' ) || die( -1 );

/**
 * Checks for excludes depending system configuration.
 *
 * @return array
 */
function irld_excludes_check() {
	global $wpdb;
	$apl               = get_option( 'active_plugins' );
	$plugins           = get_plugins();
	$activated_plugins = array();
	foreach ( $apl as $p ) {
		if ( isset( $plugins[ $p ] ) ) {
			array_push( $activated_plugins, $plugins[ $p ] );
		}
	}

	$plugtext            = '';
	$recommendedexcludes = '';
	if ( isset( $fromserver_opts['indexreloaded_excludesbyplugin'] ) ) {
		$opts = $fromserver_opts['indexreloaded_excludesbyplugin'];
	} else {
		$opts = require realpath( str_replace( 'include', '', str_replace( 'include', '', __DIR__ ) ) ) . DIRECTORY_SEPARATOR .
		str_replace( '/', DIRECTORY_SEPARATOR, 'include/tooldata/excludesbyplugin.php' );
	}

	$allactivatedplugins = '';
	$pluginmatchfound    = false;
	$plugincnt           = 0;
	$pluginexclcnt       = 0;

	$cnt_activated_plugins = count( $activated_plugins );
	foreach ( $activated_plugins as $activeplugin ) {
		if ( isset( $activeplugin['Name'] ) ) {
			$allactivatedplugins .= $activeplugin['Name'];
			foreach ( $opts as $pluginname => $plugininfo ) {
				if ( isset( $activeplugin['Name'] ) ) {
					if ( $activeplugin['Name'] === $pluginname ) {
						$pluginmatchfound = true;
						if ( isset( $plugininfo['exclude'] ) ) {
							if ( 2 === $pluginexclcnt ) {
								$plugtext .= '</p><a role="button" class="idrd-show-more button irld-button" id="btn-show-more-exp-block-3">' .
								__( 'Show more', 'indexreloaded' ) . '</a><br /><p class="irld-hide irld-hidden-part" id="hidden-exp-block-3">';
							}

							$plugtext            .= '<b>' . $activeplugin['Name'] . ':</b> ' . __( 'The following exclude(s) are needed', 'indexreloaded' ) . ':<br />';
							$plugtext            .= '&quot;' . $plugininfo['exclude'] . '&quot; - <b>' . __( 'Reason', 'indexreloaded' ) . ':</b> ' . $plugininfo['reason'] . '<br />';
							$recommendedexcludes .= $plugininfo['exclude'] . ',';
							$allactivatedplugins .= ' *';
							++$pluginexclcnt;
						}

						break;
					}
				}
			}

			$allactivatedplugins .= '<br />';
			++$plugincnt;
			if ( ( 4 === $plugincnt ) && ( $cnt_activated_plugins > 4 ) ) {
				$allactivatedplugins .= '</p><a role="button" class="idrd-show-more button irld-button" id="btn-show-more-exp-block-2">' .
					__( 'Show more', 'indexreloaded' ) . '</a><br />';
				$allactivatedplugins .= '<p class="irld-hide irld-hidden-part" id="hidden-exp-block-2">';
			}
		}
	}

	if ( $pluginexclcnt > 2 ) {
		$plugtext = '<p class="irld-fade" id="visible-exp-block-3">' . $plugtext .
		'</p><a role="button" class="idrd-show-less irld-hide button irld-button" id="btn-show-less-exp-block-3">' .
		__( 'Show less', 'indexreloaded' ) . '</a>';
	}
	// Plugins.
	// Elements used.
	$elemarr     = array();
	$elemarrpage = array();
	$rows        = $wpdb->get_results(  // phpcs:ignore WordPress.DB.DirectDatabaseQuery.DirectQuery, WordPress.DB.DirectDatabaseQuery.NoCaching
		$wpdb->prepare(
			"SELECT DISTINCT `ID` as ID, `post_title` as post_title, `post_type` as post_type, `post_type` as post_type, `post_content` as post_content 
											FROM {$wpdb->posts}
											WHERE post_type IN ('page','post') AND post_status = %s ORDER BY post_title",
			'publish'
		)
	);
	$countregs   = 0;
	if ( is_array( $rows ) ) {
		$countregs = count( $rows );
		foreach ( $rows as $postrow ) {
			$post_content     = $postrow->post_content;
			$post_content_arr = explode( '<!-- wp', $post_content );
			if ( count( $post_content_arr ) > 1 ) {
				$pick = 1;
				foreach ( $post_content_arr as $post_content_arrrow ) {
					$post_content_arrarr = explode( ' ', $post_content_arrrow );
					$elementfound        = '';
					if ( count( $post_content_arrarr ) > 1 ) {
						if ( 1 === $pick ) {
							$elementfound = $post_content_arrarr[0];
							$pick         = 0;
						} else {
							$pick = 1;
						}
					}

					if ( $elementfound ) {
						if ( 0 === count( $elemarrpage ) ) {
							$elemarrpage[ $elementfound ]        = array();
							$elemarrpage[ $elementfound ]['nbr'] = 1;
						} else {
							$iselfound = 0;
							foreach ( $elemarrpage as $elfound => &$elfoundnbr ) {
								if ( $elfound === $elementfound ) {
									++$elemarrpage[ $elfound ]['nbr'];
									$iselfound = 1;
									break;
								}
							}

							if ( 0 === $iselfound ) {
								$elemarrpage[ $elementfound ]        = array();
								$elemarrpage[ $elementfound ]['nbr'] = 1;
							}
						}
					}
				}

				if ( 0 === count( $elemarr ) ) {
					$elemarr = $elemarrpage;
				} else {
					foreach ( $elemarrpage as $elfound => $elfoundnbr ) {
						$iselfound = 0;
						foreach ( $elemarr as $efound => &$efoundnbr ) {
							if ( $elfound === $efound ) {
								++$elemarr[ $efound ]['nbr'];
								$iselfound = 1;
								break;
							}
						}

						if ( 0 === $iselfound ) {
							$elemarr[ $elfound ]        = array();
							$elemarr[ $elfound ]['nbr'] = $elfoundnbr['nbr'];
						}
					}
				}

				$elemarrpage = array();
			}

			// playlist type="video".
			$post_content_arr = explode( '[playlist type="video"', $post_content );
			if ( count( $post_content_arr ) > 1 ) {
				$elemarrpage['Video']        = array();
				$elemarrpage['Video']['nbr'] = count( $post_content_arr ) - 1;
				if ( 0 === count( $elemarr ) ) {
					$elemarr = $elemarrpage;
				} else {
					foreach ( $elemarrpage as $elfound => $elfoundnbr ) {
						$iselfound = 0;
						foreach ( $elemarr as $efound => &$efoundnbr ) {
							if ( $elfound === $efound ) {
								++$elemarr[ $efound ]['nbr'];
								$iselfound = 1;
								break;
							}
						}

						if ( 0 === $iselfound ) {
							$elemarr[ $elfound ]        = array();
							$elemarr[ $elfound ]['nbr'] = $elfoundnbr['nbr'];
						}
					}
				}

				$elemarrpage = array();
			}
		}
	}

	$elemret = '';
	if ( count( $elemarr ) > 0 ) {
		if ( isset( $fromserver_opts['indexreloaded_excludesbyelement'] ) ) {
			$opts = $fromserver_opts['indexreloaded_excludesbyelement'];
		} else {
			$opts = require realpath( str_replace( 'include', '', str_replace( 'include', '', __DIR__ ) ) ) . DIRECTORY_SEPARATOR .
			str_replace( '/', DIRECTORY_SEPARATOR, 'include/tooldata/excludesbyelement.php' );
		}

		foreach ( $elemarr as $efound => $efoundnbr ) {
			foreach ( $opts as $elementname => $elementinfo ) {
				if ( $efound === $elementname ) {
					$plugtext            .= '<b>' . $efound . ':</b> ' . __( 'The following exclude(s) are needed', 'indexreloaded' ) . ':<br />';
					$plugtext            .= '&quot;' . $elementinfo['exclude'] . '&quot; - <b>' . __( 'Reason', 'indexreloaded' ) . ':</b> ' . $elementinfo['reason'] . '<br />';
					$recommendedexcludes .= $elementinfo['exclude'] . ',';
				}
			}
		}
	}

	if ( '' !== trim( $elemret ) ) {
		$elemret = '<br><span class="irld-headdetails">' . __( 'Elements identified in pages', 'indexreloaded' ) . ':</span><br>' . trim( $elemret );
	} else {
		$elemret = '';
	}

	if ( '' !== $allactivatedplugins ) {
		$expandhead = '<p>';
		$expandfoot = '</p>';
		if ( $cnt_activated_plugins > 4 ) {
			$expandhead = '<p class="irld-fade" id="visible-exp-block-2">';
			$expandfoot = '</p><a role="button" class="idrd-show-less irld-hide button irld-button" id="btn-show-less-exp-block-2">' .
					__( 'Show less', 'indexreloaded' ) . '</a>';
		}

		$allactivatedplugins = '<br><span class="irld-headdetails">' . __( 'List of active plugins', 'indexreloaded' ) . '</span>:' . $expandhead . '' . $allactivatedplugins . '<span>' . $expandfoot;
		if ( true === $pluginmatchfound ) {
			$allactivatedplugins .= '<br /><span>' . __( '* Plugin needs attention', 'indexreloaded' ) . '</span>';
		}
	}

	// check theme.
	$themeret   = '';
	$my_theme   = wp_get_theme();
	$themefound = $my_theme->get( 'Name' );
	if ( '' !== trim( $themefound ) ) {
		$themeret = $themefound;
		if ( isset( $fromserver_opts['indexreloaded_excludesbytheme'] ) ) {
			$opts = $fromserver_opts['indexreloaded_excludesbytheme'];
		} else {
			$opts = require realpath( str_replace( 'include', '', str_replace( 'include', '', __DIR__ ) ) ) . DIRECTORY_SEPARATOR .
			str_replace( '/', DIRECTORY_SEPARATOR, 'include/tooldata/excludesbytheme.php' );
		}

		foreach ( $opts as $elementname => $elementinfo ) {
			if ( $themefound === $elementname ) {
				$plugtext            .= '<b>' . $themefound . ':</b> ' . __( 'The following exclude(s) are needed for current theme', 'indexreloaded' ) . ':<br />';
				$plugtext            .= '&quot;' . $elementinfo['exclude'] . '&quot; - <b>' . __( 'Reason', 'indexreloaded' ) . ':</b> ' . $elementinfo['reason'] . '<br />';
				$recommendedexcludes .= $elementinfo['exclude'] . ',';
			}
		}
	}

	if ( '' !== trim( $themeret ) ) {
		$themeret = '<br /><span class="irld-headdetails">' . __( 'Current theme', 'indexreloaded' ) . ':</span><br>' . trim( $themeret ) . '<br />';
	} else {
		$themeret = '';
	}

	$ret                        = array();
	$ret['themeret']            = $themeret;
	$ret['recommendedexcludes'] = $recommendedexcludes;
	$ret['plugtext']            = $plugtext;
	$ret['allactivatedplugins'] = $allactivatedplugins;
	$ret['elemret']             = $elemret;
	return $ret;
}
