<?php
/**
 *  Indexreloaded-backend. excludes by plugin.
 *
 *  @package Indexreloaded
 */

defined( 'ABSPATH' ) || die( -1 );

$ret = array(
	'Age Gate'                                     => array(
		'exclude' => 'age-gate-user-options-inline-css', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'CSS needs to be present on page when JS loads', 'indexreloaded' ),
	),
	'CookieYes | GDPR Cookie Consent'              => array(
		'exclude' => 'cky-style-inline,ckyBannerTemplate,cookie-law-info-js', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'CSS needs to be present on page when JS loads', 'indexreloaded' ),
	),
	'Elementor Pro'                                => array(
		'exclude' => 'elementor-pro-frontend-js-before', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'Contains a nonce', 'indexreloaded' ),
	),
	'hCaptcha for WordPress'                       => array(
		'exclude' => 'h-captcha:not,hcaptcha-js,hcaptcha-cf7-js,onload=hCaptchaOnLoad,hcaptcha-js-extra,hcaptcha-js', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'hCaptcha does not show up, if the inline JS, inline CSS and JS-files are touched', 'indexreloaded' ),
	),
	'Newsletter, SMTP, Email marketing and Subscribe forms by Brevo' => array(
		'exclude' => 'sib-front-js-js-extra', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'Contains a nonce', 'indexreloaded' ),
	),
	'Page Builder by SiteOrigin'                   => array(
		'exclude' => 'plugins/siteorigin-panels/js/', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'JS requires to be executed right where it is in HTML page', 'indexreloaded' ),
	),
	'Photo Gallery'                                => array(
		'exclude' => 'twb-open-sans-css', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'This is a recommendation. It is external CSS, if regrouped above the fold it may increase number of IndexReloaed-CSS files by one', 'indexreloaded' ),
	),
	'Responsive Lightbox & Gallery'                => array(
		'exclude' => 'responsive-lightbox-infinite-scroll-js,responsive-lightbox-gallery-css,responsive-lightbox-js,responsive-lightbox-gallery-inline-css,responsive-lightbox-basicslider-gallery-js-js,responsive-lightbox-basicslider-gallery-js', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'Javascript-error', 'indexreloaded' ),
	),
	'SiteOrigin Widgets Bundle'                    => array(
		'exclude' => 'plugins/so-widgets-bundle/js/', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'JS requires to be executed right where it is in HTML page', 'indexreloaded' ),
	),
	'Social Login'                                 => array(
		'exclude' => 'oneall_social_login_providers', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'Inline-JS contains values changing on every page load', 'indexreloaded' ),
	),
	'Super Socializer'                             => array(
		'exclude' => 'theChamp', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'Inline-JS, must remain in place', 'indexreloaded' ),
	),
	'User Login History'                           => array(
		'exclude' => 'user-login-history/inc/frontend/js/jquery-ui.min.js,user-login-history/inc/frontend/js/custom.js', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'Javascript-error', 'indexreloaded' ),
	),
	'WooCommerce'                                  => array(
		'exclude' => 'document.body.className = c,wcStoreApiNonceTimestamp,wp-api-fetch-js,wc-settings-js-before,WCPAY_PAYMENT_REQUEST-js-extra,wp-i18n-js,wp-hooks-js,sourcebuster-js-js', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'Javascript-errors and inline-JS containing values changing on every page load', 'indexreloaded' ),
	),
	'WooCommerce Frontend Manager'                 => array(
		'exclude' => 'product_stat_data,mediaelement-core-js-before,wp-polyfill-js-after,wp-includes/js/dist/vendor/wp-polyfill-,jquery-ui-datepicker-js,wp-includes/js/utils.,jquery.fitvids-js,var sales_data = {,jquery-chart_,wp-dom-ready-js,wp-i18n-js,wp-a11y-js-translations,clipboard-js,media-views-js-translations,media-editor-js-translations', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'Javascript-error', 'indexreloaded' ),
	),
	'WooCommerce Frontend Manager - Ultimate'      => array(
		'exclude' => 'wcfmu_vendors_followers_list,.wcfm_vendor_follower', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'Javascript-error', 'indexreloaded' ),
	),
	'Wordfence Security'                           => array(
		'exclude' => 'WordfenceTestMonBot', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'Inline-JS contains values changing on every page load', 'indexreloaded' ),
	),
	'WP Geoloc for Wordpress'                      => array(
		'exclude' => 'wpsl-gmap.min.js,initAutocomplete,rangeslider.min.js,rangeslider__ruler', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'Javascript-error', 'indexreloaded' ),
	),
	'WPForms Lite'                                 => array(
		'exclude' => 'wpforms-lite/assets/js/', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'Javascript-error', 'indexreloaded' ),
	),
	'WP Dark Mode'                                 => array(
		'exclude' => 'wp-dark-mode-js-js,wp-dark-mode-frontend-js-extra,wp-dark-mode-frontend-js,window.wpDarkMode', // phpcs:ignore WordPressVIPMinimum.Performance.WPQueryParams.PostNotIn_exclude
		'reason'  => __( 'Javascript-event does not trigger', 'indexreloaded' ),
	),
	'Classic Editor'                               => array(),
	'Contact Form 7'                               => array(),
	'Disable Comments'                             => array(),
	'File Upload Types'                            => array(),
	'IndexReloaded'                                => array(),
	'Meta Tag Manager'                             => array(),
	'Open Graph and Twitter Card Tags'             => array(),
	'Responsive WordPress Slider - Soliloquy Lite' => array(),
	'Site Kit by Google'                           => array(),
	'SiteOrigin CSS'                               => array(),
	'WP-Optimize - Clean, Compress, Cache'         => array(),
	'WP Markdown Editor (Formerly Dark Mode)'      => array(),
	'Yoast Duplicate Post'                         => array(),
	'Yoast SEO'                                    => array(),
);
return $ret;
